import { connect, Dispatch } from 'react-redux';
import {
  DiscoveryTree,
  DiscoveryTreeStateProps,
  DiscoveryTreeDispatchProps,
} from './components/DiscoveryTree';



import Host from '@overflow/discovery/api/model/Host';
import Probe from '@overflow/probe/api/model/Probe';

import * as InfraTargetRegistAllActionTypes from '../redux/action/infra_target_regist_all';
import * as asyncRequestActions from '@overflow/commons/redux/action/asyncRequest';

export function mapStateToProps(state: any, props: any): DiscoveryTreeStateProps {
  return {
    probeId: props.probeId,
    isSuccess: state.isSuccess,
  };
}

export function mapDispatchToProps(dispatch: Dispatch<any>): DiscoveryTreeDispatchProps {
  return {
    onCreateTarget: (hosts: Host[], probe: Probe) => {
      dispatch(asyncRequestActions.request('TargetDiscoveryService', 'saveAllTarget',
                                           InfraTargetRegistAllActionTypes.REQUEST, JSON.stringify(hosts), JSON.stringify(probe)));
    },
  };
}

export default connect(mapStateToProps, mapDispatchToProps)(DiscoveryTree);
